! this program clips the velocity model such that the 
! velocity values do not go lower than the floor value
program clip_vel_mod

	use sep

  	implicit none
  	
  	integer     :: nz,nx,ny,iz,ix,iy
	real		:: dz,dx,dy,oz,ox,oy
  	real		:: floor
  	real,dimension(:,:,:),allocatable :: model,data
  	
	call sep_init  	
  	
  	call from_history("n1",nz)
  	call from_history("n2",nx)
  	call from_history("n3",ny)
  	call from_history("o1",oz)
  	call from_history("o2",ox)
  	call from_history("o3",oy) 
  	call from_history("d1",dz)
  	call from_history("d2",dx)
  	call from_history("d3",dy)  	 	
  	call from_param("floor",floor)

	allocate(model(nz,nx,ny))
	allocate(data(nz,nx,ny))
	
	call sep_read(model)
	
	do iy=1,ny
		do ix=1,nx
			do iz=1,nz
				if (model(iz,ix,iy) .le. floor) then
					data(iz,ix,iy) = floor
				else
					data(iz,ix,iy) = model(iz,ix,iy)
				end if
			end do
		end do
	end do
	
	call sep_write(data)
  	call to_history("n1",nz)
  	call to_history("n2",nx)
  	call to_history("n3",ny)
  	call to_history("o1",oz)
  	call to_history("o2",ox)
  	call to_history("o3",oy) 
  	call to_history("d1",dz)
  	call to_history("d2",dx)
  	call to_history("d3",dy)				
  	
	call sep_close
  	
end program