! this code mutes direct arrivals + earlier energy on shot gather
program mute_shot

	use sep

  	implicit none
  	
  	integer     							:: nt,nr,ns,it,ir,is
	real									:: dt,dr,ds,ot,or,os,vel_mute
	real									:: s,r,dsr,t,t0
	real,dimension(:,:,:),allocatable 		:: model,data
  	
	call sep_init  	
  	
  	call from_history("n1",nt)
  	call from_history("n2",nr)
  	call from_history("n3",ns)
  	call from_history("o1",ot)
  	call from_history("o2",or)
  	call from_history("o3",os) 
  	call from_history("d1",dt)
  	call from_history("d2",dr)
  	call from_history("d3",ds)  	 	

	call from_param("vel_mute",vel_mute)
	call from_param("t0",t0)
	
	allocate(model(nt,nr,ns))
	allocate(data(nt,nr,ns))
	
	call sep_read(model)
	data = model
	
	!$OMP PARALLEL DO private(is,s,ir,r,dsr,it)		
	do is=1,ns
		s = os + (is-1) * ds
		do ir=1,nr
			r = or + (ir-1) * dr
			dsr = abs(r-s)
			t = dsr / vel_mute + t0
			it = (t-ot) / dt + 1
			data(1:it,ir,is) = 0.
		end do
	end do	
	!$OMP END PARALLEL DO 	
	
	call sep_write(data)

  	call to_history("n1",nt)
  	call to_history("n2",nr)
  	call to_history("n3",ns)

  	call to_history("o1",ot)
  	call to_history("o2",or)
  	call to_history("o3",os) 

  	call to_history("d1",dt)
  	call to_history("d2",dr)
  	call to_history("d3",ds)				
  	
	call sep_close
  	
end program