! this code applies a taper on the gradient to avoid updates in the water layer

program weight_gradient

	use sep

  	implicit none

  	integer              				:: nz,nx,z1,z0,iz,buffer
  	real								:: temp,exp
  	real,dimension(:,:),allocatable	    :: weight

  	call sep_init()
  	
  	call from_param("nz",nz)
  	call from_param("nx",nx)  	
  	call from_param("z1",z1)
  	call from_param("buffer",buffer)
  	call from_param("exp",exp,2.0)
  	
  	z0 = z1-buffer  	
  	
    allocate(weight(nz,nx)) 	
  	weight=1 
  	
  	do iz=1,z0
  		weight(iz,:) = 0  		
  	end do
  	
  	do iz=z0,z1
		temp = 1.0 - (1.0*z1-1.0*iz) / (1.0*z1-1.0*z0)
		weight(iz,:) = sin((3.14159/2*temp))**exp	
	end do
  		
  	call sep_write(weight)
    	
  	call to_history("n1",nz)  	  	
  	call to_history("n2",nx)

  	call sep_close()

end program